package main

import (
	"github.com/gin-gonic/gin"
	log "github.com/sirupsen/logrus"
	"net/http"
	"runtime/debug"
)

func recovery() gin.HandlerFunc {
	return func(context *gin.Context) {
		defer func() {
			p := recover()
			if p != nil {
				log.Errorf("Panic occurred in web server, %s", p)
				context.JSON(http.StatusInternalServerError, gin.H{
					"error": "panic",
				})
				log.Error(string(debug.Stack()))
			}
		}()
		context.Next()
	}
}
